#include "rannuMain.h"

extern VersionPane *versionPane;

#define button_data_width 32
#define button_data_height 32
static char button_data_bits[] = {
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0x0f,0x00,0x00,0xfc,0x0f,0x00,0x00,
0x0c,0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,
0x0c,0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,
0xfc,0x0f,0x00,0x00,0xfc,0x0f,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0xff,0x0f,0x00,0xfc,0xff,0x0f,0x00,
0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,
0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,
0xfc,0xff,0x0f,0x00,0xfc,0xff,0x0f,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0xff,0xff,0x0f,0xfc,0xff,0xff,0x0f,
0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,0x0c,
0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,0x0c,
0xfc,0xff,0xff,0x0f,0xfc,0xff,0xff,0x0f,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

bool VersionPane::setting() {
    using namespace std;

    const int BORDER = 3;
    const int BORDER_AREA = 20;
    const int BUTTON_X = 7;
    const int BUTTON_Y = 10;
    const string COPYRIGHT("Copyright 2017 Sogaya");
    const string NEW_LINE("\n");
    int x, y;

// Using a bitmap as the button label
    bitmapButton = new Fl_Button(BUTTON_X, BUTTON_Y, BITMAP_BUTTON_WIDTH, BITMAP_BUTTON_HEIGHT, "");
    bitmapButton->image( new Fl_Bitmap(button_data_bits, button_data_width, button_data_height) );
    bitmapButton->callback( (Fl_Callback *)help_cb, this);
    bitmapButton->box(FL_FLAT_BOX);

    closeButton = new Fl_Button(VERSION_CLOSE_LEFT, 0, BUTTON_WIDTH, BUTTON_HEIGHT, "Close");
    closeButton->callback( (Fl_Callback *)close_version_cb, this);

    x = VERSION_WIDTH/2 - VERSION_RANNU_FLTK_WIDTH/2;
    rannuFltkButton = new Fl_Button(x, VERSION_RANNU_FLTK_TOP, VERSION_RANNU_FLTK_WIDTH, BUTTON_HEIGHT, "Rannu FLTK");
    rannuFltkButton->box(FL_FLAT_BOX);

    x = VERSION_WIDTH/2 - VERSION_COPYRIGHT_WIDTH/2;
    copyrightButton = new Fl_Button(VERSION_COPYRIGHT_LEFT, VERSION_COPYRIGHT_TOP, VERSION_COPYRIGHT_WIDTH, BUTTON_HEIGHT, "Copyright 2017 Sogaya");
    copyrightButton->box(FL_FLAT_BOX);

    helpButton = new Fl_Button(VERSION_HELP_LEFT, VERSION_HELP_TOP, BUTTON_WIDTH, BUTTON_HEIGHT, "Help");
    helpButton->callback( (Fl_Callback *)help_cb, this);

    Fl_Text_Buffer *buffer = new Fl_Text_Buffer();
    y = VERSION_HEIGHT - STATUS_BAR_HEIGHT;
    Fl_Text_Display *display = new Fl_Text_Display(0, y, VERSION_WIDTH, STATUS_BAR_HEIGHT, "");
    display->buffer(buffer);
    display->textsize(20);
    display->box(FL_FLAT_BOX);

    stringstream os;
    os << "Version " << VERSION;
    string s = os.str();
    buffer->text( s.c_str() );

    helpButton->take_focus();
    return true;
}

void close_version_cb(Fl_Widget *, void *) {
    versionPane->hide();
}

void VersionPane::helpHandler() {
    executeProgram(HELP_FILE_NAME, "");
    hide();
}
